<script lang="ts">
  import { createEventDispatcher, onMount } from 'svelte';
  import { Dropdown, DropdownItem, DropdownMenu, DropdownToggle } from 'sveltestrap';
  import { TeamById } from '@models/Team';
  import { getScoreboardTeams } from '@queries/Team';
  import type { Team } from '@models/Team';
  import { KeycloakStore, KeycloakInterface } from '@auth/keycloak';

  const dispatch = createEventDispatcher();
  const teams: Array<Team> = [];
  let authenticated = false;
  let keycloak: KeycloakInterface | undefined;
  let userTeam: Team = null;
  // Whether to select disabled teams from database
  export let blueteams: Array<Team> = [];
  export let selectedTeam: Team = null;

  KeycloakStore.subscribe(async (value) => {
    // If authentication status changed, setup teams again
    keycloak = value.keycloak;
    const authChanged = keycloak?.authenticated !== authenticated;
    authenticated = !!keycloak?.authenticated;
    if (keycloak?.teamID && authenticated && authChanged) {
      userTeam = await TeamById(keycloak.teamID, keycloak.getHighestPrivilegeRole());
      await initBlueTeams();
    }
  });

  onMount(async () => {
    if (keycloak?.teamID) {
      userTeam = await TeamById(keycloak.teamID, keycloak.getHighestPrivilegeRole());
    }
    await initBlueTeams();
  });

  async function initBlueTeams() {
    blueteams = await getScoreboardTeams();
  }
</script>

<Dropdown class="mb-2 d-inline-block" setActiveFromChild>
  <DropdownToggle caret>{selectedTeam ? selectedTeam.name : 'Select team'}</DropdownToggle>
  <DropdownMenu>
    {#each blueteams as bt}
      <DropdownItem
        class="clickable"
        on:click={() => {
          selectedTeam = bt;
          dispatch('click');
        }}
      >
        {bt.name}
      </DropdownItem>
    {/each}
  </DropdownMenu>
</Dropdown>
